//+-----------------------------------------------------------------+
//|                         				  BlackScholes_oscillator     |
//|    wrote by jaguar1637@yahoo.com                                    |
//|                            http://beathespread.com                         |
//+-----------------------------------------------------------------+
#property copyright "jaguar1637@yahoo.com"
#property link      "http://beathespread.com"

#define Pi 3.141592653589793238462643
#define a1  0.31938153
#define a2 -0.356563782
#define a3 1.781477937
#define a4 -1.821255978
#define a5 1.330274429

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1   Navy
#property indicator_width1  2

//---- buffers
double Data[];

//+------------------------------------------------------------------+
extern string     DispCallPutFlag = "CallPutFlag =  0 => Cumulative CallPutFlag = 1 => product";
extern bool        BoolCallPutFlag     = 0;
string      CallPutFlag  ;

extern double 		S;
extern double 		X = 90;
extern double 		T = 20;
extern double 		r = 0.05;
extern double 		v = 0.02 ;

//---- buffers
double MyPoint;
int counted_bars, limit;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("BlackScholes_oscillator");
   IndicatorBuffers(1);
   SetIndexBuffer(0,Data);

   //------------------------------
   SetIndexLabel(0,"BlackScholes");
//----
 
	if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1))
      MyPoint = Point*10;
	else
	  if (Digits == 6 || (Digits == 4 && StringFind(Symbol(), "JPY") != -1))
        MyPoint = Point*100;
	  else
     	 MyPoint = Point;
		 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
     int i,j;
     counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----

	if (BoolCallPutFlag == 1)
		CallPutFlag = 'p';
	else
		CallPutFlag = 'c';
		
	// After I will insert EMA the HP array
	S=Close[0];
	   for (i = limit; i>0; i--)
   {
    S = Close[i];
	Data[i] =BlackScholes(S,X,T,r,v);
	}
	
	//for (j = 0; j > -10; j--)
	//{
	//S=Close[j];
	//Data[j] = BlackScholes(S,X,T,r,v);
	//}

 }
 // The Black and Scholes (1973) Stock option formula


double BlackScholes( double S, double X, double T, double r,double v)
{
	double d1, d2;
	double res;
	
	d1=(MathLog(S/X)+(r+v*v/2)*T)/(v*MathSqrt(T));
	d2=d1-v*MathSqrt(T);

	if(BoolCallPutFlag == 0)
	{
		res=  S *CumulDistrib(d1)-X * MathExp(-r*T)*CumulDistrib(d2);
		return(res);
}
	else
		if(BoolCallPutFlag == 1)
		{
			res= X * MathExp(-r * T) * CumulDistrib(-d2) - S * CumulDistrib(-d1);
			return( res);			
		}
		else 
			{
			res = 0;
			return(0);
			}
}

// The cumulative normal distribution function 
double CumulDistrib( double X )
{

	double L, K, w ;

	L = MathAbs(X);
	K = 1.0 / (1.0 + 0.2316419 * L);
	w = 1.0 - 1.0 / (MathSqrt(2 * Pi)) * (MathExp(-L *L / 2)) * ((a1 * K) + (a2 * K *K) + (a3 * MathPow(K,3)) +( a4 * MathPow(K,4) )+ (a5 * MathPow(K,5)));

if (X < 0 )
       {
       w= 1.0 - w;
       }
  return(w);
}